import platform

_getcpumemory = None
_getcpunum = None
_getcputype = None
_getmemorysize = None
_getdisk = None
_initDisk = None
_endDisk = None
_getnet = None
_getproc = None
_getlogevent = None
_initlogevent = None
_getmachinearc = None
_getServerInfoV2 = None

processes = []
system = platform.system().lower()
if 'linux' == system:
    import cpu_memory as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_linux as system_info
    _getcpunum = system_info.GetCPUNum
    _getcputype = system_info.GetCPUType
    _getmemorysize = system_info.GetMemorySize
    _getOSRelease = system_info.GetOSRelease
    import disk_linux
    _getdisk = disk_linux.getDisk
    import network_linux
    _getnet = network_linux.GetNicUtil
    import proc_linux
    _getproc = proc_linux.GetProc
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher
    _getmachinearc = system_info.GetMachineArch
elif 'sunos' == system:
    import cpu_memory_sunos as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_sunos 
    _getcpunum = system_info_sunos.GetCPUNum
    _getcputype = system_info_sunos.GetCPUType
    _getmemorysize = system_info_sunos.GetMemorySize
    _getOSRelease = system_info_sunos.GetOSRelease
    import disk_sunos 
    _getdisk = disk_sunos.getDisk
    import network_sunos
    _getnet = network_sunos.GetNicUtil
    import proc_sunos
    _getproc = proc_sunos.GetProc
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher
    _getmachinearc = system_info_sunos.GetMachineArch
    _getServerInfoV2 = system_info_sunos.GetServerInfoV2
elif 'aix' == system:
    import cpu_memory_aix as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_aix 
    _getcpunum = system_info_aix.GetCPUNum
    _getcputype = system_info_aix.GetCPUType
    _getmemorysize = system_info_aix.GetMemorySize
    _getOSRelease = system_info_aix.GetOSRelease
    import disk_aix 
    _getdisk = disk_aix.getDisk
    import network_aix
    _getnet = network_aix.GetNicUtil
    import proc_aix
    _getproc = proc_aix.GetProc
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher
    _getmachinearc = system_info_aix.GetMachineArch
    _getServerInfoV2 = system_info_aix.GetServerInfoV2
elif 'hp-ux' == system:
    import cpu_memory_hpux as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_hpux as system_info
    _getcpunum = system_info.GetCPUNum
    _getcputype = system_info.GetCPUType
    _getmemorysize = system_info.GetMemorySize
    _getOSRelease = system_info.GetOSRelease
    _getmachinearc = system_info.GetMachineArch
    import disk_hpux
    _getdisk = disk_hpux.getDisk
    import proc_hpux
    _getproc = proc_hpux.GetProc
    import network_hpux
    _getnet = network_hpux.GetNicUtil
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher
    _getServerInfoV2 = system_info_hpux.GetServerInfoV2

def GetCpuMemory():
    return _getcpumemory()

def GetCPUNum():
    return _getcpunum()

def GetCPUType():
    return _getcputype()

def GetMemorySize():
    return _getmemorysize()

def GetUptime():
    import time
    return int(time.time())

def GetDisk():
    return _getdisk()

def GetNicUtil():
    return _getnet()

def GetProc():
    return _getproc()

def GetLogEvents():
    return _getlogevent()

def InitLogEvent():
    _initlogevent()

def GetMachineArch():
    return _getmachinearc()

import tcp_check

def TCPCheckSchedule(checkurl, timeout, onPerf):
    return tcp_check.tcpCheckSchedule(checkurl, timeout, onPerf)

def GetOSRelease():
    return _getOSRelease()

def GetServerInfoV2():
    return _getServerInfoV2()
